/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.client;

import au.edu.unimelb.csse.mugle.client.ui.MugleUiBuilder;

import com.google.gwt.user.client.ui.AbsolutePanel;
import com.google.gwt.user.client.ui.Label;

public class ErrorDisplay {

    AbsolutePanel msgContainer = null;

    Label msg = null;

    String message = "";

    public ErrorDisplay() {

        this.msgContainer = MugleUiBuilder.setId(new AbsolutePanel(), "error-display");

    }

    public void addToParent(AbsolutePanel parent) {
        if (parent != null) {
            parent.add(this.msgContainer);
        }
    }

    public void clearMessage() {
        this.msgContainer.clear();
    }

    public AbsolutePanel getErrorContainer() {
        return this.msgContainer;
    }

    public String getMessage() {
        return this.message;
    }

    public void showError(String message) {
        this.message = message;
        this.msg = MugleUiBuilder.setId(new Label(message), "display-message");
        this.msg.setStylePrimaryName("error-message-show");
        this.clearMessage();
        this.msgContainer.add(msg);
    }

    public void showMessage(String message) {
        this.message = message;
        this.msg = MugleUiBuilder.setId(new Label(message), "display-message");
        this.msg.setStylePrimaryName("display-message-show");
        this.clearMessage();
        this.msgContainer.add(msg);
    }

    public void hide() {
        if (this.msg != null)
            this.msg.setStylePrimaryName("error-message-hidden");
    }

}
