/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.client.multiplayer.api;

import au.edu.unimelb.csse.mugle.shared.multiplayer.api.MessageBeanFactory;

import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

/**
 * Provides access to pre-initialised instances of all the asynchronous
 * multi-player game services offered by MUGLE.
 */
public class Services {
    /** An instance of the asynchronous multi-player game service. */
    public static final MultiPlayerGameServiceAsync multigame = GWT
            .create(MultiPlayerGameService.class);

    /** An instance of the asynchronous channel service. */
    public static final ChannelServiceAsync channel = GWT
            .create(ChannelService.class);

    /** An instance of the asynchronous game key-value service. */
    public static final GameKeyValueServiceAsync keyValue = GWT
            .create(GameKeyValueService.class);

    /** An instance of the asynchronous logging service. */
    public static final LoggingServiceAsync logging = GWT
            .create(LoggingService.class);

    /** An instance of the asynchronous transaction service. */
    public static final TransactionServiceAsync transaction = GWT
            .create(TransactionService.class);

    /** An instance of the MessageBeanFactory. */
    public static final MessageBeanFactory messageFactory = GWT
            .create(MessageBeanFactory.class);

    static {
        ((ServiceDefTarget) channel).setServiceEntryPoint("/mugle/api-channel");
        ((ServiceDefTarget) multigame)
                .setServiceEntryPoint("/mugle/api-multiPlayerGame");
        ((ServiceDefTarget) keyValue)
                .setServiceEntryPoint("/mugle/api-gameKeyValue");
        ((ServiceDefTarget) logging).setServiceEntryPoint("/mugle/api-logging");
        ((ServiceDefTarget) transaction)
                .setServiceEntryPoint("/mugle/api-transaction");
    }
}
