package au.edu.unimelb.csse.mugle.client.multiplayer.api;

import au.edu.unimelb.csse.mugle.shared.multiplayer.api.Transaction;
import com.google.gwt.user.client.rpc.AsyncCallback;

public interface TransactionServiceAsync {

    /**
     * Create a new transaction.
     * 
     * @param instanceToken
     *            The secret token for the game instance to join.
     * @param transaction
     *            The transaction to be created.
     * @param callback
     *            The transaction id.
     */
    void createTransaction(String instanceToken, Transaction transaction,
            AsyncCallback<String> callback);

    /**
     * Confirm a transaction.
     * 
     * @param instanceToken
     *            The secret token for the game instance to join.
     * @param transactionId
     *            The id for the confirmed transaction.
     */
    void confirmTransaction(String instanceToken, String transactionId,
            AsyncCallback<Void> callback);

}
