/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.client.ui;

import com.google.gwt.user.client.ui.Widget;

/**
 * This is used to show Error 404
 *
 */
public class NotFoundViewBuilder extends ViewBuilder {

    /**
     * Default constructor
     */
    public NotFoundViewBuilder() {
        super();
    }

    /**
     *Constructor that takes the url fragment
     * @param urlFragment
     */
    public NotFoundViewBuilder(String urlFragment) {
        super(urlFragment);
    }

    @Override
    public Widget buildView() {

        this.clearPanel();
        this.getDataPanel().add(this.getError404());
        // Set the window title
        this.setWindowTitle("MUGLE - Page Not Found");
        return this.getDataPanel();

    }

}
