/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.client.ui.admin;

import au.edu.unimelb.csse.mugle.client.Mugle;
import au.edu.unimelb.csse.mugle.client.ui.ViewBuilder;
import au.edu.unimelb.csse.mugle.shared.model.Role;

import com.google.gwt.user.client.ui.*;

public class AdminViewBuilder extends ViewBuilder {

    @Override
    public Widget buildView() {

        FlowPanel panel = this.getDataPanel();

        panel.clear();

        if (Mugle.getAuthUser().getUser().getRole() != Role.ADMIN) {
            panel.add(this.getAuthorizationError(Role.ADMIN));
            return panel;
        }

        return this.constructView(panel);

    }

    private Widget constructView(FlowPanel panel) {

        String text = "This is the Admin main page.";
        panel.add(new Label(text));

        text = "TODO: add any links or messages here.";
        panel.add(new Label(text));

        text = "TODO: this should have the funtionality to show dynamic messages.";
        panel.add(new Label(text));

        return panel;

    }

}
