/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package au.edu.unimelb.csse.mugle.server;

import com.google.appengine.api.users.User;
import com.google.appengine.api.users.UserService;
import com.google.appengine.api.users.UserServiceFactory;
import au.edu.unimelb.csse.mugle.client.LoginInfo;
import au.edu.unimelb.csse.mugle.client.ClientService;
import com.google.gwt.user.server.rpc.RemoteServiceServlet;

@SuppressWarnings("serial")
public class ClientServiceImpl extends RemoteServiceServlet implements ClientService {

  public LoginInfo login(String requestUri) {
    UserService userService = UserServiceFactory.getUserService();
    User user = userService.getCurrentUser();
    LoginInfo loginInfo = new LoginInfo();

    loginInfo = getCurrentUser();
    if (user != null) {
      loginInfo.setLogoutUrl(userService.createLogoutURL(requestUri));
    } else {
      loginInfo.setLoginUrl(userService.createLoginURL(requestUri));
    }
    return loginInfo;
  }
  
  /* For server side purposes only,
   * Gets the currently logged in user as above, but without the
   * Host's url.  Used in most server side service implementations
   */
  public LoginInfo getCurrentUser() {
      UserService userService = UserServiceFactory.getUserService();
      User user = userService.getCurrentUser();
      LoginInfo loginInfo = new LoginInfo();
      
      if (user != null) {
          loginInfo.setLoggedIn(true);
          loginInfo.setEmailAddress(user.getEmail());
          loginInfo.setNickname(user.getNickname());
          loginInfo.setUserID(user.getUserId());
          loginInfo.setAdmin(userService.isUserAdmin());
      } else {
          loginInfo.setLoggedIn(false);
      }
      return loginInfo;
  }

}
