/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.server.model;

import au.edu.unimelb.csse.mugle.shared.model.ClientView;
import au.edu.unimelb.csse.mugle.shared.model.Role;

/**
 * This is a simple holder class for the user's current role and
 * client view. This is useful since ModelWrapper and other services
 * require both these properties together almost always.
 */
public class RoleAndView {

    private Role role;

    private ClientView clientView;

    private UserData user;

    public RoleAndView() {
        this.role = Role.GUEST;
        this.clientView = ClientView.PUBLIC;
        this.user = null;
    }

    public RoleAndView(Role role, ClientView cview) {
        this.role = role;
        this.clientView = cview;
        this.user = null;
    }

    public RoleAndView(Role role, ClientView cview, UserData user) {
        this.role = role;
        this.clientView = cview;
        this.user = user;
    }

    public Role getRole() {
        return this.role;
    }

    public void setRole(Role role) {
        this.role = role;
    }

    public ClientView getClientView() {
        return this.clientView;
    }

    public void setClientView(ClientView clientView) {
        this.clientView = clientView;
    }

    public UserData getUser() {
        return user;
    }

    public void setUser(UserData user) {
        this.user = user;
    }

}
