/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.server.multiplayer.model;

import java.util.HashSet;
import java.util.Set;

import javax.jdo.annotations.IdGeneratorStrategy;
import javax.jdo.annotations.PersistenceCapable;
import javax.jdo.annotations.Persistent;
import javax.jdo.annotations.PrimaryKey;

import com.google.appengine.api.datastore.Key;

@PersistenceCapable
public class PendingPlayerData {
    @PrimaryKey
    @Persistent(valueStrategy = IdGeneratorStrategy.IDENTITY)
    private Key id;

    @Persistent
    private Set<Key> players;

    @Persistent
    private Key game;

    public PendingPlayerData() {
        this.players = new HashSet<Key>();
    }

    public Key getServerKey() {
        return this.id;
    }

    public void setServerKey(Key id) {
        this.id = id;
    }

    public Set<Key> getPlayers() {
        return this.players;
    }

    public void addPlayer(Key player) {
        this.players.add(player);
    }

    public void removePlayer(Key player) {
        this.players.remove(player);
    }

    public void setPlayers(Set<Key> players) {
        this.players = players;
    }

    public Key getGame() {
        return game;
    }

    public void setGame(Key game) {
        this.game = game;
    }
}
