/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package au.edu.unimelb.csse.mugle.shared;

import java.io.Serializable;
import java.util.ArrayList;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * Class used to test if the storing of Serialized classes works
 * for KeyValuePairs
 * @author scott
 *
 */
public class KVPtester implements Serializable, IsSerializable {
    /**
     *
     */
    private static final long serialVersionUID = -3990456510360602352L;

    private String string;
    private Integer intTest;
    private ArrayList<Boolean> array;

    public KVPtester(String s, Integer i) {
        this.setString(s);
        this.setIntTest(i);
        this.array = new ArrayList<Boolean>();
    }

    public void setString(String string) {
        this.string = string;
    }

    public String getString() {
        return string;
    }

    public void setIntTest(Integer intTest) {
        this.intTest = intTest;
    }

    public Integer getIntTest() {
        return intTest;
    }

    public void addToArray(boolean b) {
        this.array.add((Boolean)b);
    }

    public ArrayList<Boolean> getArray() {
        return array;
    }

    public String toString() {
        String s = this.string + ", " + Integer.toString(this.intTest);
        for (Boolean b : this.array) {
            s += b.toString() + ", ";
        }
        return s;
    }
}
