/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.api;

import com.google.gwt.user.client.rpc.IsSerializable;

/** An error for the key-value store; a key was not found.
 */
public class KeyError extends Exception implements IsSerializable {
    private static final long serialVersionUID = 2248222166311987494L;

    private String key;

    public KeyError()
    {
        super();
        this.key = null;
    }

    public KeyError(String key)
    {
        super("Key not found: " + key);
        this.key = key;
    }

    public String getKey()
    {
        return this.key;
    }
}
