/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.model;

/*
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
*/

import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.IsSerializable;

import au.edu.unimelb.csse.mugle.shared.model.annotations.*;

@MugleDataWrapper
public class KeyValuePair extends ModelClientClass<Long, KeyValuePair> {

    private static final long serialVersionUID = 1429455155450290553L;

    // Fields

    private Long ugp;

    private String key;
    
    private IsSerializable value;

    // Constructors
    
    public KeyValuePair() {        
        this.key = null;
        this.ugp = null;
        this.value = null;
    }
    
    // Getters

    public String getKey() {
        return this.key;
    }

    public Long getUserGameProfile() {
        return this.ugp;
    }

    public IsSerializable getValue() {
        // TODO Still HACKED        
        /*
        ByteArrayInputStream byteStream = new ByteArrayInputStream(this.value);
        try {
            return (new ObjectInputStream(byteStream)).readObject();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return null;
        */
        return this.value;
    }
        
    public void addToUserGameProfile(UserGameProfile ugp,
            AsyncCallback<UpdatedPair<KeyValuePair, UserGameProfile>> callback) {
        DataProvider.getKeyValuePairService().addToUserGameProfile(this, ugp, callback);
    }
    
    public void removeFromUserGameProfile(UserGameProfile ugp,
            AsyncCallback<UpdatedPair<KeyValuePair, UserGameProfile>> callback) {
        DataProvider.getKeyValuePairService().removeFromUserGameProfile(this, ugp, callback);
    }
    

    // Setters
        
    public void setKey(String key) {
        this.key = key;
    }

    public void setUserGameProfileKey(Long ugp) {
        this.ugp = ugp;
    }

    public Boolean setValue(Object value) {
        // TODO Still HACKED
        /*
        ByteArrayOutputStream byteStream = new ByteArrayOutputStream();
        ObjectOutput out;
        try {
            out = new ObjectOutputStream(byteStream);
            out.writeObject(this.value);
            this.value = byteStream.toByteArray();
            return true;
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }   
        return false;
        */
        return false;
    }
    
    
    // ModelClass - common methods

    @Override
    public Class<KeyValuePair> getClassType() {
        return KeyValuePair.class;
    }
    
    @Override
    public void write(AsyncCallback<KeyValuePair> callback) {
        DataProvider.getKeyValuePairService().write(this, callback);
    }
    
    
    // Static methods
    
    public static void getByKey(Long key, AsyncCallback<KeyValuePair> callback) {
        DataProvider.getKeyValuePairService().getByKey(key, callback);
    }
    
    public static void getByPairKey(String key, String gameToken, AsyncCallback<KeyValuePair> callback) {
        DataProvider.getKeyValuePairService().getByPairKey(key, gameToken, callback);
    }
        
}
