/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.model;

import java.io.Serializable;
import java.util.HashSet;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * A holder to return sets of model class objects
 *
 */
public class ModelCollection<T extends ModelClientClass<?,T>> implements Serializable, IsSerializable {

    private static final long serialVersionUID = 2346295853697624848L;

    // Fields
    
    private HashSet<T> collection;
    
    private int capacity = 0;
    
    private int startIndex = 0;
    
    private int endIndex = 0;
    
    /**
     * Default constructor required for serialization
     */
    public ModelCollection() {
        this.collection = new HashSet<T>();
    }
    
    public ModelCollection(int size) {
        this.collection = new HashSet<T>(size);
    }

    public HashSet<T> getCollection() {
        return this.collection;
    }

    public void setCollection(HashSet<T> collection) {
        this.collection = collection;
    }

    public int getCapacity() {
        return this.capacity;
    }

    public void setCapacity(int capacity) {
        this.capacity = capacity;
    }

    public int getStartIndex() {
        return this.startIndex;
    }

    public void setStartIndex(int startIndex) {
        this.startIndex = startIndex;
    }

    public int getEndIndex() {
        return this.endIndex;
    }

    public void setEndIndex(int endIndex) {
        this.endIndex = endIndex;
    }
    
    public int getCount() {
        if (this.collection == null) { return 0; }
        return this.collection.size();
    }

}
