/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.model;

import com.google.gwt.user.client.rpc.AsyncCallback;

import au.edu.unimelb.csse.mugle.shared.model.annotations.*;

@MugleDataWrapper
public class PromotedGame extends ModelClientClass<Long, PromotedGame>  {

    private static final long serialVersionUID = -7822465832242079100L;

    // Fields
    
    private String urlName;

    private Long gameVersion;


    // Constructors

    public PromotedGame() {
        this.urlName = null;
        this.gameVersion = null;
    }


    // Getters
    
    public String getUrlName() {
        return this.urlName;
    }
    
    public Long getGameVersionKey() {
        return this.gameVersion;
    }


    // Setters
    
    public void setGameVersionKey(Long game) {
        this.gameVersion = game;
    }

    public void setUrlName(String urlName) {
        this.urlName = urlName;
    }
    
    
    // ModelClass - common methods

    @Override
    public Class<PromotedGame> getClassType() {
        return PromotedGame.class;
    }
    
    public void create(AsyncCallback<PromotedGame> callback) {
        DataProvider.getPromotedGameService().create(this, callback);
    }
    
    public void remove(AsyncCallback<Void> callback) {
        DataProvider.getPromotedGameService().remove(this, callback);
    }
    
    @Override
    public void write(AsyncCallback<PromotedGame> callback) {
        DataProvider.getPromotedGameService().write(this, callback);
    }
    
    
    // Static methods
    
    public static void getByKey(Long key, AsyncCallback<PromotedGame> callback) {
        DataProvider.getPromotedGameService().getByKey(key, callback);
    }
    
    public static void getByName(String name, AsyncCallback<PromotedGame> callback) {
        DataProvider.getPromotedGameService().getByName(name, callback);
    }
    
}
