/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.model.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import au.edu.unimelb.csse.mugle.shared.model.Role;

/**
 * This annotation is used to check if all elements of a clients wrapper class
 * has the fields' user levels set.
 */
@Target(ElementType.TYPE)
@Retention(RetentionPolicy.RUNTIME)
public @interface MugleDataWrapper {
    Role privateAdd() default Role.GUEST;
    Role privateUpdate() default Role.GUEST;
    Role privateRemove() default Role.GUEST;
    Role publicAdd() default Role.GUEST;
    Role publicUpdate() default Role.GUEST;
    Role publicRemove() default Role.GUEST;
}
