/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package au.edu.unimelb.csse.mugle.shared.model.services;

import au.edu.unimelb.csse.mugle.shared.model.*;

import com.google.gwt.user.client.rpc.AsyncCallback;

public interface AchievementServiceAsync {
    
    void getByKey(Long key,
            AsyncCallback<Achievement> callback);
    
    void getByName(String name, Game game,
            AsyncCallback<Achievement> callback);
    
    void getByName(String name, String gameToken,
            AsyncCallback<Achievement> callback);
    
    void create(Achievement object,
            AsyncCallback<Achievement> callback);
    
    void write(Achievement object,
            AsyncCallback<Achievement> callback);

    void getUserAchievements(Achievement achievement,
            AsyncCallback<ModelCollection<UserAchievement>> callback);

    void addUserAchievement(Achievement achievement,
            UserAchievement userAchievement,
            AsyncCallback<UpdatedPair<Achievement, UserAchievement>> callback);

    void removeUserAchievement(Achievement achievement,
            UserAchievement userAchievement,
            AsyncCallback<UpdatedPair<Achievement, UserAchievement>> callback);

    void remove(Achievement object, AsyncCallback<Void> callback);

    void remove(ModelCollection<Achievement> achievements,
            AsyncCallback<Void> callback);

}
