/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package au.edu.unimelb.csse.mugle.shared.model.services;

import au.edu.unimelb.csse.mugle.shared.model.*;

import com.google.gwt.user.client.rpc.AsyncCallback;

public interface DevTeamServiceAsync {

    void getByKey(Long key,
            AsyncCallback<DevTeam> callback);

    void getByName(String name,
            AsyncCallback<DevTeam> callback);
    
    void create(DevTeam object,
            AsyncCallback<DevTeam> callback);
    
    void write(DevTeam object,
            AsyncCallback<DevTeam> callback);

    void getGames(DevTeam devTeam, Boolean includePrivate,
            AsyncCallback<ModelCollection<Game>> callback);

    void addGame(DevTeam devTeam, Game game,
            AsyncCallback<UpdatedPair<DevTeam, Game>> callback);

    void removeGame(DevTeam devTeam, Game game,
            AsyncCallback<UpdatedPair<DevTeam, Game>> callback);

    void getUsers(DevTeam devTeam,
            AsyncCallback<ModelCollection<User>> callback);

    void addUser(DevTeam devTeam, User user,
            AsyncCallback<UpdatedPair<DevTeam, User>> callback);

    void removeUser(DevTeam devTeam, User user, 
            AsyncCallback<UpdatedPair<DevTeam, User>> callback);

    void getDevTeams(int startIndex, int count,
            AsyncCallback<ModelCollection<DevTeam>> callback);

    void remove(DevTeam object,
            AsyncCallback<Void> callback);

    void remove(ModelCollection<DevTeam> teams, 
            AsyncCallback<Void> callback);

}
