/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package au.edu.unimelb.csse.mugle.shared.model.services;

import au.edu.unimelb.csse.mugle.shared.model.*;
import au.edu.unimelb.csse.mugle.shared.platform.exceptions.*;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;

@RemoteServiceRelativePath("data-game-file")
public interface GameFileService extends RemoteService {
    
    GameFile getByKey(Long key)
        throws ServerException, GameFileNotExists;

    GameFile getByPath(GameVersion gameVersion, String path)
        throws ServerException, GameFileNotExists, GameVersionNotExists;

    GameFile getByPath(Game game, int gameVersion, String path)
        throws ServerException, GameFileNotExists, GameVersionNotExists;

    GameFile getByPath(String devteamName, String gameName, int gameVersion,
        String path)
        throws ServerException, GameFileNotExists, GameVersionNotExists;

    GameFile create(GameFile object)
        throws ServerException, UserPrivilegeException, GameFileExists, GameVersionNotExists;

    GameFile write(GameFile object)
        throws ServerException, UserPrivilegeException, GameFileNotExists, GameVersionNotExists;

    void remove(GameFile object)
        throws ServerException, UserPrivilegeException, GameFileNotExists, GameVersionNotExists;

}
