/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package au.edu.unimelb.csse.mugle.shared.model.services;

import au.edu.unimelb.csse.mugle.shared.model.*;

import com.google.gwt.user.client.rpc.AsyncCallback;

public interface GameServiceAsync {

    void getByKey(Long key,
            AsyncCallback<Game> callback);

    void getByName(String devteamName, String name,
            AsyncCallback<Game> callback);

    void getByGameToken(String token,
            AsyncCallback<Game> callback);

    void create(Game object,
            AsyncCallback<Game> callback);

    void write(Game object,
            AsyncCallback<Game> callback);

    void getAchievements(Game game,
            AsyncCallback<ModelCollection<Achievement>> callback);

    void addAchievement(Game game, Achievement achievement,
            AsyncCallback<UpdatedPair<Game, Achievement>> callback);

    void removeAchievement(Game game, Achievement achievement,
            AsyncCallback<UpdatedPair<Game, Achievement>> callback);

    void getGameVersions(Game game,
            AsyncCallback<ModelCollection<GameVersion>> callback);

    void addGameVersion(Game game, GameVersion version,
            AsyncCallback<UpdatedPair<Game, GameVersion>> callback);

    void removeGameVersion(Game game, GameVersion version,
            AsyncCallback<UpdatedPair<Game, GameVersion>> callback);

    void getUserGameProfiles(Game game,
            AsyncCallback<ModelCollection<UserGameProfile>> callback);

    void addUserGameProfile(Game game, UserGameProfile ugp,
            AsyncCallback<UpdatedPair<Game, UserGameProfile>> callback);

    void removeUserGameProfile(Game game, UserGameProfile ugp,
            AsyncCallback<UpdatedPair<Game, UserGameProfile>> callback);

    void addToDevTeam(Game game, DevTeam devTeam,
            AsyncCallback<UpdatedPair<Game, DevTeam>> callback);

    void removeFromDevTeam(Game game, DevTeam devTeam,
            AsyncCallback<UpdatedPair<Game, DevTeam>> callback);

    void remove(Game object, AsyncCallback<Void> callback);

    void getGames(int startIndex, int count,
            AsyncCallback<ModelCollection<Game>> callback);

    void getActiveGames(int startIndex, int count,
            AsyncCallback<ModelCollection<Game>> callback);

    void getMyGames(int startIndex, int count,
            AsyncCallback<ModelCollection<Game>> callback);

}
