/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package au.edu.unimelb.csse.mugle.shared.model.services;

import au.edu.unimelb.csse.mugle.shared.api.GameTokenError;
import au.edu.unimelb.csse.mugle.shared.model.*;
import au.edu.unimelb.csse.mugle.shared.platform.exceptions.*;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;

@RemoteServiceRelativePath("data-key-value")
public interface KeyValuePairService extends RemoteService {

    KeyValuePair getByKey(Long key)
        throws ServerException, KeyValuePairNotExists, UserPrivilegeException;
    
    KeyValuePair getByPairKey(String key, String gameToken)
        throws ServerException, KeyValuePairNotExists, GameTokenError;

    KeyValuePair write(KeyValuePair object)
        throws ServerException, UserPrivilegeException, KeyValuePairNotExists, UserGameProfileNotExists;

    UpdatedPair<KeyValuePair, UserGameProfile>
        addToUserGameProfile(KeyValuePair kvp, UserGameProfile ugp)
            throws ServerException, KeyValuePairNotExists, UserGameProfileNotExists, UserPrivilegeException;
    
    UpdatedPair<KeyValuePair, UserGameProfile>
        removeFromUserGameProfile(KeyValuePair kvp, UserGameProfile ugp)
            throws ServerException, KeyValuePairNotExists, UserGameProfileNotExists, UserPrivilegeException;

}
