/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package au.edu.unimelb.csse.mugle.shared.model.services;

import au.edu.unimelb.csse.mugle.shared.model.*;

import com.google.gwt.user.client.rpc.AsyncCallback;

public interface KeyValuePairServiceAsync {

    void getByKey(Long key,
            AsyncCallback<KeyValuePair> callback);

    void getByPairKey(String key, String gameToken,
            AsyncCallback<KeyValuePair> callback);

    void write(KeyValuePair object,
            AsyncCallback<KeyValuePair> callback);

    void addToUserGameProfile(KeyValuePair kvp, UserGameProfile ugp,
            AsyncCallback<UpdatedPair<KeyValuePair, UserGameProfile>> callback);

    void removeFromUserGameProfile(KeyValuePair kvp, UserGameProfile ugp,
            AsyncCallback<UpdatedPair<KeyValuePair, UserGameProfile>> callback);

}
