/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package au.edu.unimelb.csse.mugle.shared.model.services;

import au.edu.unimelb.csse.mugle.shared.model.*;
import au.edu.unimelb.csse.mugle.shared.platform.exceptions.*;

import com.google.gwt.user.client.rpc.RemoteService;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;

@RemoteServiceRelativePath("data-user-achievement")
public interface UserAchievementService extends RemoteService {

    UserAchievement getByKey(Long key)
        throws ServerException, UserAchievementNotExists;
    
    UserAchievement getByUserGameProfile(UserGameProfile ugp, Achievement achievement)
        throws ServerException, UserAchievementNotExists;

    UserAchievement write(UserAchievement object)
        throws ServerException, UserPrivilegeException, UserAchievementNotExists, UserGameProfileNotExists;

    UpdatedPair<UserAchievement, UserGameProfile>
        addToUserGameProfile(UserAchievement userAchievement, UserGameProfile ugp)
            throws ServerException, UserAchievementNotExists, UserGameProfileNotExists, UserPrivilegeException;

    UpdatedPair<UserAchievement, UserGameProfile>
        removeFromUserGameProfile(UserAchievement userAchievement, UserGameProfile ugp)
            throws ServerException, UserAchievementNotExists, UserGameProfileNotExists, UserPrivilegeException;

    UpdatedPair<UserAchievement, Achievement>
        addToAchievement(UserAchievement userAchievement, Achievement achievement)
            throws ServerException, UserAchievementNotExists, AchievementNotExists, UserPrivilegeException, UserGameProfileNotExists;

    UpdatedPair<UserAchievement, Achievement>
        removeFromAchievement(UserAchievement userAchievement, Achievement achievement)
            throws ServerException, UserAchievementNotExists, AchievementNotExists, UserPrivilegeException, UserGameProfileNotExists;

}
