/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package au.edu.unimelb.csse.mugle.shared.model.services;

import au.edu.unimelb.csse.mugle.shared.model.*;

import com.google.gwt.user.client.rpc.AsyncCallback;

public interface UserGameProfileServiceAsync {

    void getByKey(Long key, 
            AsyncCallback<UserGameProfile> callback);

    void getByUserAndGame(User user, Game game,
            AsyncCallback<UserGameProfile> callback);
    
    void write(UserGameProfile object,
            AsyncCallback<UserGameProfile> callback);

    void getKeyValuePairs(UserGameProfile ugp,
            AsyncCallback<ModelCollection<KeyValuePair>> callback);

    void addKeyValuePair(UserGameProfile ugp, KeyValuePair kvp,
            AsyncCallback<UpdatedPair<UserGameProfile, KeyValuePair>> callback);

    void removeKeyValuePair(UserGameProfile ugp, KeyValuePair kvp,
            AsyncCallback<UpdatedPair<UserGameProfile, KeyValuePair>> callback);

    void getUserAchievements(UserGameProfile ugp,
            AsyncCallback<ModelCollection<UserAchievement>> callback);

    void addUserAchievement(UserGameProfile ugp,
            UserAchievement userAhievement, 
            AsyncCallback<UpdatedPair<UserGameProfile, UserAchievement>> callback);

    void removeUserAchievement(UserGameProfile ugp,
            UserAchievement userAhievement,
            AsyncCallback<UpdatedPair<UserGameProfile, UserAchievement>> callback);

    void addToUser(UserGameProfile ugp, User user,
            AsyncCallback<UpdatedPair<UserGameProfile, User>> callback);

    void removeFromUser(UserGameProfile ugp, User user,
            AsyncCallback<UpdatedPair<UserGameProfile, User>> callback);

    void addToGame(UserGameProfile ugp, Game game,
            AsyncCallback<UpdatedPair<UserGameProfile, Game>> callback);

    void removeFromGame(UserGameProfile ugp, Game game,
            AsyncCallback<UpdatedPair<UserGameProfile, Game>> callback);
    
}
