/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package au.edu.unimelb.csse.mugle.shared.model.services;

import au.edu.unimelb.csse.mugle.shared.model.*;

import com.google.gwt.user.client.rpc.AsyncCallback;

public interface UserServiceAsync {

    void getByKey(Long key, 
            AsyncCallback<User> callback);
    
    void getByName(String urlName, 
            AsyncCallback<User> asyncCallback);
    
    void getLoggedInUser(AsyncCallback<User> callback);
    
    void create(User object,
            AsyncCallback<User> callback);

    void write(User object,
            AsyncCallback<User> callback);

    void getDevTeams(User user,
            AsyncCallback<ModelCollection<DevTeam>> callback);

    void joinDevTeam(User user, DevTeam devTeam,
            AsyncCallback<UpdatedPair<User, DevTeam>> callback);

    void leaveDevTeam(User user, DevTeam devTeam,
            AsyncCallback<UpdatedPair<User, DevTeam>> callback);

    void getUserGameProfiles(User user,
            AsyncCallback<ModelCollection<UserGameProfile>> callback);

    void addUserGameProfile(User user, UserGameProfile ugp,
            AsyncCallback<UpdatedPair<User, UserGameProfile>> callback);

    void removeUserGameProfile(User user, UserGameProfile ugp,
            AsyncCallback<UpdatedPair<User, UserGameProfile>> callback);

    void getUsers(int startIndex, int count,
            AsyncCallback<ModelCollection<User>> callback);

    void getUsersByRole(Role role, int startIndex, int count,
            AsyncCallback<ModelCollection<User>> callback);
    
}
