package au.edu.unimelb.csse.mugle.shared.multiplayer.api;

import java.io.Serializable;
import java.util.List;

import com.google.gwt.user.client.rpc.IsSerializable;

/** An action to be run in a transaction. */

public interface Action extends Serializable, IsSerializable {
    /**
     * A list of users involved in the action.
     */
    public List<String> getUsers();

    /**
     * A string representation of this action, including the name and affected
     * users/data of the action.
     */
    public String actionString();
}
