/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.multiplayer.api;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Set;

/** Message AutoBean interface */
public interface MessageBean {

    public String getBody();

    public String getCommand();

    public Map<String, String> getAttributeValuePairs();

    public Map<String, List<String>> getAttributeListPairs();

    public ServerCommand getServerCommand();

    public String getSender();

    public int getCounter();

    public Set<String> getReceivers();

    public String getInstanceToken();

    public Date getTimestamp();

    public void setBody(String body);

    public void setCommand(String command);

    public void setAttributeValuePairs(Map<String, String> attributeValuePairs);

    public void setAttributeListPairs(
            Map<String, List<String>> attributeListPairs);

    public void setServerCommand(ServerCommand command);

    public void setSender(String sender);

    public void setCounter(int counter);

    public void setReceivers(Set<String> receivers);

    public void setInstanceToken(String instanceToken);

    public void setTimestamp(Date timestamp);

}
