/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.multiplayer.model;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import au.edu.unimelb.csse.mugle.shared.model.ModelClientClass;
import au.edu.unimelb.csse.mugle.shared.model.ModelList;
import au.edu.unimelb.csse.mugle.shared.multiplayer.model.services.MultiPlayerPlatformServices;

import com.google.gwt.user.client.rpc.AsyncCallback;

public class GameLog extends ModelClientClass<Long, GameLog> {

    /**
     * 
     */
    private static final long serialVersionUID = -3942168784673176604L;
    private Map<String, String> keyStringPairs;
    private Map<String, List<String>> keyListPairs;
    private boolean hasLogMessages;
    private String token;

    public Map<String, String> getKeyStringPairs() {
        return keyStringPairs;
    }

    public boolean hasLogMessages() {
        return hasLogMessages;
    }

    public void setHasLogMessages(boolean hasLogMessages) {
        this.hasLogMessages = hasLogMessages;
    }

    public void addKeyString(String key, String string) {
        if (keyStringPairs == null)
            keyStringPairs = new HashMap<String, String>();
        keyStringPairs.put(key, string);
    }

    public void setKeyStringPairs(Map<String, String> keyStringPairs) {
        this.keyStringPairs = keyStringPairs;
    }

    public Map<String, List<String>> getKeyListPairs() {
        return keyListPairs;
    }

    public void addKeyList(String key, List<String> list) {
        if (keyListPairs == null)
            keyListPairs = new HashMap<String, List<String>>();
        keyListPairs.put(key, list);
    }

    public void setKeyListPairs(Map<String, List<String>> keyListPairs) {
        this.keyListPairs = keyListPairs;
    }

    @Override
    public Class<GameLog> getClassType() {
        return GameLog.class;
    }

    @Override
    public void write(AsyncCallback<GameLog> callback) {
        throw new UnsupportedOperationException();
    }

    public static void getGameLogs(String instanceToken,
            AsyncCallback<ModelList<GameLog>> callback) {
        MultiPlayerPlatformServices.gameMonitor.getGameLogs(instanceToken, callback);
    }

    public static void getLogMessageCount(String logToken,
            AsyncCallback<Integer> callBack) {
        MultiPlayerPlatformServices.gameMonitor
                .getLogMessageCount(logToken, callBack);
    }

    public static void getLogMessages(String logToken, int startIndex,
            int count, AsyncCallback<ModelList<LogMessage>> callBack) {
        MultiPlayerPlatformServices.gameMonitor.getLogMessages(logToken, startIndex,
                count, callBack);
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }

}
