/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.multiplayer.model;

import java.util.Set;

import au.edu.unimelb.csse.mugle.shared.model.ModelClientClass;
import au.edu.unimelb.csse.mugle.shared.model.annotations.MugleDataWrapper;

import com.google.gwt.user.client.rpc.AsyncCallback;

@MugleDataWrapper
public class LogMessage extends ModelClientClass<Long, LogMessage> {

    /**
	 * 
	 */
    private static final long serialVersionUID = 2579191809646547995L;

    private String body;
    private String sender;
    private Set<String> receivers;

    public String getBody() {
        return body;
    }

    public void setBody(String body) {
        this.body = body;
    }

    public String getSender() {
        return sender;
    }

    public void setSender(String sender) {
        this.sender = sender;
    }

    public Set<String> getReceivers() {
        return receivers;
    }

    public void setReceivers(Set<String> receivers) {
        this.receivers = receivers;
    }

    @Override
    public Class<LogMessage> getClassType() {
        return LogMessage.class;
    }

    @Override
    public void write(AsyncCallback<LogMessage> callback) {
        throw new UnsupportedOperationException();
    }
}
