/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.multiplayer.model.services;

import au.edu.unimelb.csse.mugle.shared.model.Game;
import au.edu.unimelb.csse.mugle.shared.model.ModelCollection;
import au.edu.unimelb.csse.mugle.shared.model.ModelList;
import au.edu.unimelb.csse.mugle.shared.model.User;
import au.edu.unimelb.csse.mugle.shared.multiplayer.model.GameInstance;
import au.edu.unimelb.csse.mugle.shared.multiplayer.model.GameLog;
import au.edu.unimelb.csse.mugle.shared.multiplayer.model.LogMessage;

import com.google.gwt.user.client.rpc.AsyncCallback;

public interface GameMonitorServiceAsync {

    void getGameInstances(Game game, int startIndex, int count,
            AsyncCallback<ModelList<GameInstance>> callback);

    void getPlayers(GameInstance instance,
            AsyncCallback<ModelCollection<User>> callback);

    void getInstanceCount(Game game, AsyncCallback<Integer> callback);

    void getSortedGameInstances(Game game, int startIndex, int count,
            String sortBy, AsyncCallback<ModelList<GameInstance>> callback);

    void getGameLogs(String instanceToken,
            AsyncCallback<ModelList<GameLog>> callback);

    void getLogMessageCount(String logToken, AsyncCallback<Integer> callback);

    void getLogMessages(String logToken, int startIndex, int count,
            AsyncCallback<ModelList<LogMessage>> callback);
}
