/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.platform.exceptions;

import au.edu.unimelb.csse.mugle.shared.model.DevTeam;

/**
 * Exception used when a given dev team does not exist.
 */
public class DevTeamNotExists extends MugleException {

    private static final long serialVersionUID = -2291599659199415783L;

        public DevTeamNotExists() {
        super();
    }
    
    public DevTeamNotExists(DevTeam devTeam) {
        super("DevTeam '" + devTeam.getUrlName() + "' does not exist.");
    }
    
    public DevTeamNotExists(String urlName) {
        super("DevTeam '" + urlName + "' does not exist.");
    }
    
    public DevTeamNotExists(Long id) {
        super("DevTeam with ID '" + id + "' does not exist.");
    }
}