package au.edu.unimelb.csse.mugle.shared.platform.exceptions;

public class GameFileNotExists extends MugleException {

    private static final long serialVersionUID = 728229816363066583L;

    public GameFileNotExists() {
        super();
    }
    
    public GameFileNotExists(Long primaryKey) {
        super("The gameFile with primary key " + primaryKey.toString() + " does not exist");
    }
    
    public GameFileNotExists(String gameName, String gameVersion, String path) {
        super("The file " + path + " for version " + gameVersion + 
                        " of " + gameName + " does not exist.");
    }

    public GameFileNotExists(String gameVersion, String path) {
        super("The file " + path + " for version " + gameVersion +
                        " of <unknown game> does not exist.");
    }
}
