/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.platform.exceptions;

import au.edu.unimelb.csse.mugle.shared.model.Game;

/**
 * Exception used when a given game does not exists.
 */
public class GameNotExists extends MugleException {

    private static final long serialVersionUID = -8476438905241133536L;

    public GameNotExists() {
        super();
    }
    
    public GameNotExists(Game game) {
        super("Game '" + game.getUrlName() + "' does not exist.");
    }
    
    public GameNotExists(String gameName) {
        super("Game '" + gameName + "' does not exist.");
    }
    
    public GameNotExists(String teamName, String gameName) {
        super("Game '" + gameName + "' by team '" + teamName
              + "' does not exist.");
    }
    
    public GameNotExists(Long id) {
        super("Game with ID '" + id + "' does not exist.");
    }
}
