/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.platform.exceptions;

import au.edu.unimelb.csse.mugle.shared.model.KeyValuePair;

/**
 * Exception used when a given key value pair does not exist.
 */
public class KeyValuePairNotExists extends MugleException {

    private static final long serialVersionUID = -8993337127389326656L;

    public KeyValuePairNotExists() {
        super();
    }
    
    public KeyValuePairNotExists(KeyValuePair kvp) {
        super("KeyValuePair with key '" + kvp.getKey() + "' does not exist.");
    }
    
    public KeyValuePairNotExists(Long id) {
        super("KeyValuePair with ID '" + id + "' does not exist.");
    }
    
}