/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.platform.exceptions;

import au.edu.unimelb.csse.mugle.shared.model.Game;
import au.edu.unimelb.csse.mugle.shared.model.User;

public class UserGameProfileExists extends MugleException {

    private static final long serialVersionUID = 6661496179360820256L;

    public UserGameProfileExists() {
        super();
    }
    
    public UserGameProfileExists(User u, Game g) {
        super("A UserGameProfile for the User " + u.getUrlName() + " for the game " + g.getUrlName() + " already exists.");
    }

    public UserGameProfileExists(Long primaryKey) {
        super("A UserGameProfile with the primary key: " + primaryKey + " already exists.");
    }
}
