
/*  Melbourne University Game-based Learning Environment
 *  Copyright (C) 2011 The University of Melbourne
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package au.edu.unimelb.csse.mugle.shared.platform.exceptions;

import au.edu.unimelb.csse.mugle.shared.model.User;
import au.edu.unimelb.csse.mugle.shared.model.Role;

public class UserPrivilegeException extends MugleException {

    private static final long serialVersionUID = -7858440125459465573L;

    /**
     *
     * @param u The user that's trying the operation
     * @param r The required role
     */
    public UserPrivilegeException (User u, Role r) {
        super ("User " + u.getFullName() + " does not have the the right privilege for"
               + " this operation to be performed. " + u.getFullName() + "is: " 
               + u.getRole().toString() + " where " + r.toString() + " is required.");
    }
    
    /**
     * Default constructor
     */
    public UserPrivilegeException() {
        super("The current user does not have the the right privilege for"
              + " this operation to be performed.");
    }
    
    /**
     * Constructor with custom message
     */
    public UserPrivilegeException(String msg) {
        super(msg);
    }
   
}
